bzoj 1046 : [HAOI2007]上升序列 dp

题目链接

1046: [HAOI2007]上升序列

Time Limit: 10 Sec  Memory Limit: 162 MB
Submit: 3620  Solved: 1236
[Submit][Status][Discuss]

Description

对于一个给定的S={a1,a2,a3,…,an},若有P={ax1,ax2,ax3,…,axm},满足(x1 < x2 < … < xm)且( ax1 < ax2 < … < axm)。那么就称P为S的一个上升序列。如果有多个P满足条件,那么我们想求字典序最小的那个。任务给出S序列,给出若干询问。对于第i个询问,求出长度为Li的上升序列,如有多个,求出字典序最小的那个(即首先x1最小,如果不唯一,再看x2最小……),如果不存在长度为Li的上升序列,则打印Impossible.

Input

第一行一个N,表示序列一共有N个元素第二行N个数,为a1,a2,…,an 第三行一个M,表示询问次数。下面接M行每行一个数L,表示要询问长度为L的上升序列。

Output

对于每个询问,如果对应的序列存在,则输出,否则打印Impossible.

Sample Input

6
3 4 1 2 3 6
3
6
4
5

Sample Output

Impossible
1 2 3 6
Impossible

HINT

数据范围

N<=10000

M<=1000

我们不能知道从某个位置开始的最长上升序列的长度, 但是我们可以知道以某个位置结束的最长下降序列的长度, 所以倒过来求一下最长下降子序列的长度就可以了。

这里的字典序并不是开头的数字的大小而是开头数字的坐标大小。

#include <iostream>
#include <vector>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <stack>
#include <bitset>
using namespace std;
#define pb(x) push_back(x)
#define ll long long
#define mk(x, y) make_pair(x, y)
#define lson l, m, rt<<1
#define mem(a) memset(a, 0, sizeof(a))
#define rson m+1, r, rt<<1|1
#define mem1(a) memset(a, -1, sizeof(a))
#define mem2(a) memset(a, 0x3f, sizeof(a))
#define rep(i, n, a) for(int i = a; i<n; i++)
#define fi first
#define se second
typedef pair<int, int> pll;
const double PI = acos(-1.0);
const double eps = 1e-8;
const int mod = 1e9+7;
const int inf = 1061109567;
const int dir[][2] = { {-1, 0}, {1, 0}, {0, -1}, {0, 1} };
int a[100005], dp[100005], stk[100000];
int main()
{
    int n, m, len = 0;
    cin>>n;
    for(int i = n; i>=1; i--) {
        scanf("%d", &a[i]);
        dp[i] = 1;
    }
    for(int i = 2; i<=n; i++) {
        for(int j = 1; j<i; j++) {
            if(a[j]>a[i]) {
                dp[i] = max(dp[i], dp[j]+1);
            }
        }
        len = max(len, dp[i]);
    }
    reverse(a+1, a+n+1);
    reverse(dp+1, dp+1+n);
    int x;
    cin>>x;
    while(x--) {
        scanf("%d", &m);
        if(len < m) {
            puts("Impossible");
            continue;
        }
        int p = 0, last = -inf;
        for(int i = 1; i<=n&&m!=0; i++)
            if(dp[i]>=m&&a[i]>last) {
                stk[++p] = i;
                m--;
                last = a[i];
            }
        for(int i = 1; i<p; i++)
            printf("%d ", a[stk[i]]);
        printf("%d\n",a[stk[p]]);
    }
    return 0;
}
时间: 2024-11-05 20:37:14

bzoj 1046 : [HAOI2007]上升序列 dp的相关文章

BZOJ 1046: [HAOI2007]上升序列 LIS -dp

1046: [HAOI2007]上升序列 Time Limit: 10 Sec  Memory Limit: 162 MBSubmit: 3438  Solved: 1171[Submit][Status][Discuss] Description 对于一个给定的S={a1,a2,a3,…,an},若有P={ax1,ax2,ax3,…,axm},满足(x1 < x2 < … < xm)且( ax1 < ax2 < … < axm).那么就称P为S的一个上升序列.如果有多

1046: [HAOI2007]上升序列(dp)

1046: [HAOI2007]上升序列 Time Limit: 10 Sec  Memory Limit: 162 MBSubmit: 4999  Solved: 1738[Submit][Status][Discuss] Description 对于一个给定的S={a1,a2,a3,…,an},若有P={ax1,ax2,ax3,…,axm},满足(x1 < x2 < … < xm)且( ax1 < ax2 < … < axm).那么就称P为S的一个上升序列.如果有多

BZOJ 1046: [HAOI2007]上升序列(LIS)

题目挺坑的..但是不难.先反向做一次最长下降子序列.然后得到了d(i),以i为起点的最长上升子序列,接下来贪心,得到字典序最小. ------------------------------------------------------------------- #include<cstdio> #define rep(i,n) for(int i=0;i<n;++i) using namespace std; const int maxn=10005; const int inf=0

[BZOJ 1046] [HAOI2007] 上升序列 【DP】

题目链接:BZOJ - 1046 题目分析 先倒着做最长下降子序列,求出 f[i],即以 i 为起点向后的最长上升子序列长度. 注意题目要求的是 xi 的字典序最小,不是数值! 如果输入的 l 大于最长上升子序列长度,输出 Impossible. 否则,从 1 向 n 枚举,贪心,如果 f[i] >= l,就选取 a[i],同时 --l,然后继续向后找比 a[i] 大的第一个数判断是否 f[i] >= l (这时l已经减小了1). 代码 #include <iostream> #i

bzoj 1046: [HAOI2007]上升序列【dp+二分】

先从后到前做一个最长下降子序列的dp,记录f[i],我这里用的是二分(其实树状数组比较显然) 然后对于询问,超出最长上升子序列的直接输出:否则从前到后扫,f[i]>=x&&a[i]>la(上个选的)就选,因为这时第一个出现的一定是符合条件的中最小的最小的 #include<iostream> #include<cstdio> using namespace std; const int N=10005; int n,a[N],m,x,f[N],p[N],

BZOJ 1046 [HAOI2007]上升序列

题解:f[i]表示以i开头的最长上升子序列长度 贪心先选下标最小的符合要求的元素 #include<iostream> #include<cstdio> #include<cstring> #include<algorithm> using namespace std; const int maxn=10009; int n,T; int maxlen; int a[maxn]; int b[maxn],nn; int c[maxn]; int lowbit

【BZOJ】1046 : [HAOI2007]上升序列

1046: [HAOI2007]上升序列 题意:给定S={a1,a2,a3,…,an}问是否存在P={ax1,ax2,ax3,…,axm},满足(x1 < x2 < … < xm)且( ax1 < ax2 < … < axm),若存在多组符合长度为m的递增子序列,则输出以序号字典序最小的:并非是数值 Sample Input 6 3 4 1 2 3 6 3 6 4 5 Sample Output Impossible 1 2 3 6 Impossible 数据范围 N&

【BZOJ 1046】 1046: [HAOI2007]上升序列

1046: [HAOI2007]上升序列 Description 对于一个给定的S={a1,a2,a3,-,an},若有P={ax1,ax2,ax3,-,axm},满足(x1 < x2 < - < xm)且( ax1 < ax2 < - < axm).那么就称P为S的一个上升序列.如果有多个P满足条件,那么我们想求字典序最小的那个.任务给出S序列,给出若干询问.对于第i个询问,求出长度为Li的上升序列,如有多个,求出字典序最小的那个(即首先x1最小,如果不唯一,再看x2

[BZOJ1046][HAOI2007]上升序列 DP+贪心

题目链接:http://www.lydsy.com/JudgeOnline/problem.php?id=1046 我们先求出对于每一个数字作为开头的LCS的长度f[i],最长的f[i]为mxlen. 对于每一个询问,我们选取答案,从第1个开始选.假设当前已经选到了第x个答案,我们只需要一直往后面找到第一个f[k]且f[k]+x>mxlen,它就是第x+1个答案. 这样时间复杂度就是$O(nm)$的,感觉玄学卡过…… 1 #include<cstdio> 2 #include<cs